<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<?LassoScript

	if: !(global_defined: '__startup_loglevel__');
		global: '__startup_loglevel__' = 'none';
	/if;

	var: 'security_token' = 'admin';

	auth: -realm='Lasso Site ' + lasso_siteid + ' Admin', -NoResponse;
	
	include: (lassoapp_link: 'library.lasso');
	
	_admin_nocache;
	
	var: 'response_filepath'=(response_filepath);

?>
<html>
	<head>
		<title>[var: 'admin_title', -encodenone]</title>
		<style>[include: (lassoapp_link: 'default_css.lasso')]</style>
	</head>
	<?LassoScript

		// This variable holds the default tab for each section
		_admin_addvar: -name='admin_memory', -session='_siteadmin', -default=(map);

		// Library One

		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_memory->(find: '_root');
		/If;
		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_tab_array1->(get:1)->first;
		/If;
		$admin_memory->(insert: '_root' = $admin_tab1);

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Library Two

		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = $admin_memory->(find: $admin_tab1);
		/If;
		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = (_admin_array_find: $admin_tab_array2, $admin_tab1)->(get:1)->first;
		/If;
		$admin_memory->(insert: $admin_tab1 = $admin_tab2);

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/library.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Reset admin_link based on actual tab visited

		var: 'admin_link' = $admin_file +
			'?tab1=' + $admin_tab1 +
			'&tab2=' + $admin_tab2 +
			'&-session=_groupadmin:' + (session_id: -name='_groupadmin') +
			'&increment=' + $admin_increment;
	?>

	</head>

		<div id="frame_main" class="frame_main">

[if: (client_type >> 'MSIE') && (client_type >> 'Mac_PowerPC')]
			<div id="header_tab1" align="center">
				<img class="graphic_left" src="[lassoapp_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.omnipilot.com/" target="_new"><img class="graphic_right" src="[lassoapp_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $temp->First]" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="[lassoapp_link:'images/blank.gif']" border="0" alt="" width="1" height="1" />&nbsp;&nbsp;&nbsp;[encode_html: $temp->Second]&nbsp;&nbsp;&nbsp;<img class="corner_right1" src="[lassoapp_link:'images/blank.gif']" border="0" alt="" width="1" height="1" /></a>[/loop]
			</div>
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array2, $admin_tab1)]
			<div id="header_tab2">[Iterate: $temp_array, (Variable: 'temp')]
				<a href="[Response_FilePath]?tab1=[encode_url: $admin_tab1]&tab2=[encode_url: $temp->First]" class="tab2[If: $temp->First == $admin_tab2] active2[/If]"><img class="corner_left2" src="images/1x1.gif" border="0" alt="" width="1" height="1" />&nbsp;&nbsp;&nbsp;[encode_html: $temp->Second]&nbsp;&nbsp;&nbsp;<img class="corner_right2" src="images/1x1.gif" border="0" alt="" width="1" height="1" /></a>[/Iterate]
			</div>
[else]
			<div id="header_tab1" class="header_tab1" align="center">
				<img class="graphic_left" src="[lassoapp_link:'images/logo_left.jpg']" alt="" width="144" height="36" />
				<a href="http://www.omnipilot.com/" target="_new"><img class="graphic_right" src="[lassoapp_link:'images/logo_right.jpg']" alt="" width="144" height="36" border=0 /></a>[loop: $admin_tab_array1->size][var: 'temp' = $admin_tab_array1->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $temp->First]" class="tab1[If: $temp->First == $admin_tab1] active1[/If]"><img class="corner_left1" src="[lassoapp_link:'images/corner_ffffff_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab1">[encode_html: $temp->Second]</span><img class="corner_right1" src="[lassoapp_link:'images/corner_ffffff_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[Variable: 'temp_array' = (_admin_array_find: $admin_tab_array2, $admin_tab1)]
			<div id="header_tab2" class="header_tab2">[loop: $temp_array->size][var: 'temp' = $temp_array->(get: loop_count)]
				<a href="[Response_FilePath]?tab1=[encode_url: $admin_tab1]&tab2=[encode_url: $temp->First]" class="tab2[If: $temp->First == $admin_tab2] active2[/If]"><img class="corner_left2" src="[lassoapp_link:'images/corner_999999_left.gif']" border="0" alt="" width="2" height="2" /><span class="tab2">[encode_html: $temp->Second]</span><img class="corner_right2" src="[lassoapp_link:'images/corner_999999_right.gif']" border="0" alt="" width="2" height="2" /></a>[/loop]
			</div>
[/if]

	<?LassoScript
				
		// Default One

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

		// Default Two

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (lassoapp_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/default.lasso'));
			Handle: (Error_Msg != '') && (Error_Code != 0) && (Error_Msg !>> 'could not be found in the LassoApp') && (Error_Msg !>> 'was not found');
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;

	?>

			<div id="frame_footer" class="frame_footer">
				<table style="margin:0px">
					<tr>
						<th width="36"><a href="[var: 'admin_link']?migrat_action=refresh">Refresh</a></th>
						<td align="center">Group Admin</td>
						<th width="36"><a href="[response_filepath]?logout=true">Logout</a></th>
					</tr>
				</table>
			</div>

		</div>
		<p>&copy; 1996[if: date->year > 1996]-[date->year][/if] OmniPilot Software, Inc.</p>

<!-- [/inline] -->

	</body>
</html>
