<?LassoScript

//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'list_all_maxrecords';
session_addvar: -name='_reference', 'list_all_skiprecords';
session_addvar: -name='_reference', 'list_all_found_count';
session_addvar: -name='_reference', 'list_all_category';
session_addvar: -name='_reference', 'list_all_inline';

//
// Base Inline
//

variable: 'list_all_inline' = $ref_tag_inline;

//
// Navigation Parameters
//

if: (var_defined: 'list_all_navigation') && (var_defined: 'list_all_found_count') && (var_defined: 'list_all_skiprecords') && (var_defined: 'list_all_maxrecords');
	if: ($list_all_navigation >> 'Prev');
		var: 'temp' = (math_min: $list_all_found_count, (math_max: 0, (math_sub: $list_all_skiprecords, $list_all_maxrecords)));
		$list_all_inline->(insert: -SkipRecords=$temp);
	else: ($list_all_navigation >> 'Next');
		var: 'temp' = (math_min: $list_all_found_count, (math_max: 0, (math_add: $list_all_skiprecords, $list_all_maxrecords)));
		$list_all_inline->(insert: -SkipRecords=$temp);
	/if;
/if;

//
// Search Parameters
//

$list_all_inline->(insert: -search='');
$list_all_inline->(insert: -maxrecords=60);
$list_all_inline->(insert: 'tag_display'='Y');

$list_all_inline->(insert: -SortField='tag_category');
$list_all_inline->(insert: -SortField='tag_sort');

//
// Perform the Search
//

inline: -log=$__startup_loglevel__, $list_all_inline, -inlinename='list_all_results';
	var: 'list_all_found_count' = (found_count);
	var: 'list_all_shown_count' = (shown_count);
	var: 'list_all_shown_first' = (shown_first);
	var: 'list_all_shown_last' = (shown_last);
	var: 'list_all_maxrecords' = (maxrecords_value);
	var: 'list_all_skiprecords' = (skiprecords_value);
/inline;

?>
