<?LassoScript

//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'advanced_action';

session_addvar: -name='_reference', 'advanced_tag';
session_addvar: -name='_reference', 'advanced_category';
session_addvar: -name='_reference', 'advanced_type';
session_addvar: -name='_reference', 'advanced_set';
session_addvar: -name='_reference', 'advanced_support';
session_addvar: -name='_reference', 'advanced_platform';
session_addvar: -name='_reference', 'advanced_datasource';
session_addvar: -name='_reference', 'advanced_description';
session_addvar: -name='_reference', 'advanced_edition';
session_addvar: -name='_reference', 'advanced_version';
session_addvar: -name='_reference', 'advanced_change';
session_addvar: -name='_reference', 'advanced_output';
session_addvar: -name='_reference', 'advanced_security';
session_addvar: -name='_reference', 'advanced_implementation';
session_addvar: -name='_reference', 'advanced_sourceavailable';

session_addvar: -name='_reference', 'advanced_sort';
session_addvar: -name='_reference', 'advanced_maxrecords';
session_addvar: -name='_reference', 'advanced_skiprecords';
session_addvar: -name='_reference', 'advanced_found_count';
session_addvar: -name='_reference', 'advanced_mode';
session_addvar: -name='_reference', 'advanced_inline';

//
// Define Default Variables
//

variable_default: 'advanced_action', 'Search';
variable_default: 'advanced_sort', 'Name';
variable_default: 'advanced_set', 'Any';

if: (var: 'advanced_mode') == 'Search';
	if: (action_param: 'advanced_tag') == '';
		var: 'advanced_tag'='';
	/if;
	if: (action_param: 'advanced_description') == '';
		var: 'advanced_description'='';
	/if;
	if: (action_param: 'advanced_output') == '';
		var: 'advanced_output'='';
	/if;
/if;

if: ($advanced_action == 'Clear');
	var: 'advanced_tag'='';
	var: 'advanced_category'='Any';
	var: 'advanced_type'='Any';
	var: 'advanced_set'='Any';
	var: 'advanced_support'='Any';
	var: 'advanced_platform'='Any';
	var: 'advanced_datasource'='Any';
	var: 'advanced_description'='';
	var: 'advanced_edition'='Any';
	var: 'advanced_version'='Any';
	var: 'advanced_change'='Any';
	var: 'advanced_security'='Any';
	var: 'advanced_implementation'='Any';
	var: 'advanced_sourceavailable'='Any';
	var: 'advanced_output'='';

	var: 'advanced_sort'='Name';
	var: 'advanced_found_count'=0;
/if;

if: (var_defined: 'advanced_mode');

	//
	// Base Inline
	//

	variable: 'advanced_inline' = $ref_tag_inline;

	//
	// Sorting Parameters
	//

	if: (var_defined: 'advanced_sort');
		if: ($advanced_sort >> 'Name');
			$advanced_inline->(insert: -SortField='tag_sort');
		else: ($advanced_sort >> 'Type');
			$advanced_inline->(insert: -SortField='tag_type');
			$advanced_inline->(insert: -SortField='tag_sort');
		else: ($advanced_sort >> 'Set');
			$advanced_inline->(insert: -SortField='tag_language');
			$advanced_inline->(insert: -SortField='tag_sort');
		else: ($advanced_sort >> 'Support');
			$advanced_inline->(insert: -SortField='tag_support');
			$advanced_inline->(insert: -SortField='tag_sort');
		/if;
	/if;

	//
	// Navigation Parameters
	//

	if: (var_defined: 'advanced_navigation') && (var_defined: 'advanced_found_count') && (var_defined: 'advanced_skiprecords') && (var_defined: 'advanced_maxrecords');
		if: ($advanced_navigation >> 'Prev');
			var: 'temp' = (math_min: $advanced_found_count, (math_max: 0, (math_sub: $advanced_skiprecords, $advanced_maxrecords)));
			$advanced_inline->(insert: -SkipRecords=$temp);
		else: ($advanced_navigation >> 'Next');
			var: 'temp' = (math_min: $advanced_found_count, (math_max: 0, (math_add: $advanced_skiprecords, $advanced_maxrecords)));
			$advanced_inline->(insert: -SkipRecords=$temp);
		/if;
	/if;

	//
	// Search Parameters
	//

	$advanced_inline->(insert: -search='');
	$advanced_inline->(insert: -maxrecords=15);
	$advanced_inline->(insert: -op='eq');
	$advanced_inline->(insert: 'tag_display'='Y');

	if: ($advanced_action == 'Search');
		if: (var:'advanced_tag')!='Any';
			$advanced_inline->(insert: -op='cn');
			$advanced_inline->(insert: 'tag_name'=(var: 'advanced_tag'));
		/if;
		if: (var:'advanced_category')!='Any';
			$advanced_inline->(insert: 'tag_category'=(var: 'advanced_category'));
		/if;
		if: (var:'advanced_type')!='Any';
			$advanced_inline->(insert: 'tag_type'=(var: 'advanced_type'));
		/if;
		if: (var:'advanced_set')!='Any';
			$advanced_inline->(insert: -op='cn');
			$advanced_inline->(insert: 'tag_language'=(var: 'advanced_set'));
		/if;
		if: (var:'advanced_support')!='Any';
			$advanced_inline->(insert: 'tag_support'=(var: 'advanced_support'));
		/if;
		if: (var:'advanced_platform')!='Any';
			$advanced_inline->(insert: 'tag_platform'=(var: 'advanced_platform'));
		/if;
		if: (var:'advanced_datasource')!='Any';
			$advanced_inline->(insert: 'tag_datasource'=(var: 'advanced_datasource'));
		/if;
		if: (var:'advanced_description')!='Any';
			$advanced_inline->(insert: -op='cn');
			$advanced_inline->(insert: 'tag_description'=(var: 'advanced_description'));
		/if;
		if: (var:'advanced_edition')!='Any';
			$advanced_inline->(insert: 'tag_edition'=(var: 'advanced_edition'));
		/if;
		if: (var:'advanced_version')!='Any';
			$advanced_inline->(insert: 'tag_version'=(var: 'advanced_version'));
		/if;
		if: (var:'advanced_change')!='Any';
			$advanced_inline->(insert: 'tag_history'=(var: 'advanced_change'));
		/if;
		if: (var:'advanced_output')!='Any';
			$advanced_inline->(insert: -op='cn');
			$advanced_inline->(insert: 'tag_output'=(var: 'advanced_output'));
		/if;
		if: (var:'advanced_security')!='Any';
			$advanced_inline->(insert: -op='cn');
			$advanced_inline->(insert: 'tag_security'=(var: 'advanced_security'));
		/if;
		if: (var:'advanced_implementation')!='Any';
			$advanced_inline->(insert: -op='cn');
			$advanced_inline->(insert: 'tag_implementation'=(var: 'advanced_implementation'));
		/if;
		if: (var:'advanced_sourceavailable')!='Any';
			$advanced_inline->(insert: -op='cn');
			$advanced_inline->(insert: 'tag_sourceavailable'=(var: 'advanced_sourceavailable'));
		/if;
	/if;

	//
	// Perform the Search
	//
	if: ($advanced_action != 'Clear');
		inline: -log=$__startup_loglevel__, $advanced_inline, -inlinename='search';
			var: 'advanced_found_count' = (found_count);
			var: 'advanced_shown_count' = (shown_count);
			var: 'advanced_shown_first' = (shown_first);
			var: 'advanced_shown_last' = (shown_last);
			var: 'advanced_maxrecords' = (maxrecords_value);
			var: 'advanced_skiprecords' = (skiprecords_value);
						
		/inline;
	/if;
/if;

?>
