<?LassoScript

_admin_addvar: 'action', -override=(action_param: 'action');
_admin_addvar: 'recursion_enable', -override=(action_param: 'recursion_enable');
_admin_addvar: 'execution_enable', -override=(action_param: 'execution_enable');

// ---------
// prefs

var: 'settings_defaults' = (map: 
		'recursion_limit' = 50,
		'execution_timelimit' = 600,
		'lasso_classic_enabled' = 'N',
		'error_reporting' = 'minimal',
		'default_page_encoding' = 'UTF-8',
		'lasso_apps_enabled' = 'Y',
		'lasso_digest_auth' = 'N',
	);		
var: 'settings_prefs' = $settings_defaults;
var: 'settings_prefs' = (admin_getpref: $settings_prefs);


// ---------
// action

if: (var:'action') >> 'Update';

	var: 'old_encoding' = $settings_prefs->(find: 'default_page_encoding');
	
	iterate: $settings_prefs->keys, (var: 'key');
		if: (action_param: $key, -count) > 0;
			if: (action_param: $key) == '';
				$settings_prefs->(insert: $key = $settings_defaults->(find: $key));
			else;
				$settings_prefs->(insert: $key = (action_param: $key));
			/if;
		/if;
	/iterate;

	if: $settings_prefs->(find: 'default_page_encoding') >> '..';
		$settings_prefs->(insert: 'default_page_encoding' = (action_param: 'page_encoding_other'));
	/if;

	if: !(string_validcharset: $settings_prefs->(find: 'default_page_encoding'));
		if: $old_encoding != '';
			$settings_prefs->(insert: 'default_page_encoding' = $old_encoding);
		else;
			$settings_prefs->(insert: 'default_page_encoding' = $settings_defaults->(find: 'default_page_encoding'));
		/if;
	/if;

	if: $recursion_enable >> 'N';
		$settings_prefs->(insert: 'recursion_limit' = 0);
	/if;

	if: $execution_enable >> 'N';
		$settings_prefs->(insert: 'execution_timelimit' = 0);
	/if;
	
	if: ($settings_prefs->(find: 'execution_timelimit') < 60) && ($settings_prefs->(find: 'execution_timelimit') != 0);
		$settings_prefs->(insert: 'execution_timelimit' = 60);
	/if;

	admin_setpref: $settings_prefs;
	
	protect;
		_execution_timelimit: $settings_prefs->(find: 'execution_timelimit');
	/protect;

	protect;
		_recursion_limit: $settings_prefs->(find: 'recursion_limit');
	/protect;

	protect;
		lasso_errorreporting: $settings_prefs->(find: 'error_reporting'), -global;
	/protect;
	
	global: '__encoding__' = $settings_prefs->(find: 'default_page_encoding');

	global: '__digest_auth__' = $settings_prefs->(find: 'lasso_digest_auth');

	_security_flushcaches;

/if;

?>
