<?LassoScript

	// replacement for the old client_ip == '127.0.0.*' functionality
	define_type('ip',
		-namespace='_global_client_');
		local('data' = _client_ip_old);
	
		// do smart comparisons
		define_tag('onCompare');
	
			// params may be a list item comma delimited items
			// these are OR not AND
	
			local('mainList' = string(params->get(1))->split(','));
	
			if(#mainList->size == 0); // no items
				return(-1);
			/if;
	
			local('lhs' = self->data->split('.'));
	
			iterate: #mainList, local('i');
				#i->trim;
	
				if(string_isdigit(#i));
					#i = (Client_IPFromInteger(#i));
				/if;
	
				if(#i->size == 0);
					return(-1);
				/if;
	
				local('rhs' = #i->split('.'));
				local('result' = 0);
	
				iterate: #rhs, (local('j'));
					if((#lhs->get(loop_count) != #j) && (#j != '*'));
						#result = -1;
					/if;
				/iterate;
				return(#result);
			/iterate;
	
			return(-1); // just in case
		/define_tag;
	
		// when called normally, need to output the client_ip_old tag
		define_tag('onConvert');
			if(params->get(1) == 'string');
				return(self->data);
			else;
				return(client_iptointeger(self->data));
			/if;
		/define_tag;
	/define_type;
	
	// turn an ip address into an integer
	define_tag('IPToInteger',
		-required = 'ip',
		-namespace = '_global_Client_');
	
		fail_if((#ip->type != 'string') && (#ip->type != 'client_ip') && (#ip->type != 'ip'), -1, 'IP type needs to be string or client_ip');

		if((#ip->type == 'client_ip') || (#ip->type == 'ip'));
			local('_ip' = string(#ip));
		else;
			local('_ip' = #ip);
		/if;

		fail_if(#_ip->split('.')->size != 4, -1, 'Incorrect quad decimal IP address');
	
		local(
			'result' = 0,
			'm' = 256 * 256 * 256);
	
		iterate: #_ip->split('.'), local('i');
			#result += (integer(#i) * #m);
			#m /= 256;
		/iterate;
	
		return(#result);
	/define_tag;
	
	// turn an integer into an IP address
	define_tag('IPFromInteger',
		-required = 'ip',
		-namespace = '_global_Client_');
	
		local(
			'x' = integer(#ip),
			'result' = array,
			'm' = 256 * 256 * 256);
	
		loop(4);
			#result->insert(#x / #m);
			#x %= #m;
			#m /= 256;
		/loop;
	
		return(string(#result->join('.')));
	/define_tag;
	
	// replacement for the old client_address == '*.edu' functionality
	define_type('address',
		-namespace='_global_client_');
		local('data' = _client_address_old);
	
		// do smart comparisons
		// works almost the same as client_ip, except compares from back to front
		define_tag('onCompare');
	
			// simple check to see if they do equal each other first
			if(string(params->get(1)) == self->data);
				return(0);
			/if;
	
			// params may be a comma dlist item comma delimited items
			local('mainList' = string(params->get(1))->split(','));
	
			if(#mainList->size == 0); // no items
				return(-1);
			/if;
	
			iterate: #mainList, local('i');
				#i->trim;
	
				#i->replace('.', '\\.');
				#i->replace('*', '.*');

				protect;
					if(string_findregexp(-find = #i, self->data)->size == 1);
						return(0);
					/if;
					handle_error;
						return(-1);
					/handle_error;
				/protect;
			/iterate;
	
			return(-1);
		/define_tag;
	
		// when called normally, need to output the client_ip_old tag
		define_tag('onConvert');
			return(self->'data');
		/define_tag;
	
	/define_type;
	
	define_type('addr', -namespace='_global_client_', 'client_address');
	/define_type;

	//QUERY_STRING
	define_tag('GetArgs', -namespace='_global_Client_', -priority='replace');
		return(string(_request_param('kfor')));
	/define_tag;
 
	//QUERY_STRING args returned as array
	define_tag('GetParams', -namespace='_global_Client_', -priority='replace');
		if(! var_defined('__client_getparams__'));
			var('__client_getparams__' = _chop_args(string(_request_param('kfor')), '&'));
			$__client_getparams__->freezevalue;
		/if;
		return(var('__client_getparams__'));
	/define_tag;

	//post args
	define_tag('PostArgs', -namespace='_global_Client_', -priority='replace');
		return(_request_param('post'));
	/define_tag;

	//same as above, returned as array
	define_tag('PostParams', -namespace='_global_Client_', -priority='replace');
		if(! var_defined('__client_postparams__'));
			var('__client_postparams__' = _chop_args(string(_request_param('post')), '&'));
			$__client_postparams__->freezevalue;
		/if;
		return(var('__client_postparams__'));
	/define_tag;

	//multiple cookies returned
	//in a ';'-separated string
	define_tag('CookieList', -namespace='_global_Client_', -priority='replace');
		return(string(_request_param('koky')));
	/define_tag;

	//array containing cookie name/value pairs
	define_tag('Cookies', -namespace='_global_Client_', -priority='replace');
		if(! var_defined('__client_cookies__'));
			var('__client_cookies__' = _chop_args(_request_param('koky'),'; '));
			$__client_cookies__->freezevalue;
		/if;
		return(var('__client_cookies__'));
	/define_tag;

	// REQUEST_METHOD
	define_tag('FormMethod', -namespace='_global_Client_', -priority='replace');
		return(string(_request_param('meth')));
	/define_tag;

	//CONTENT_TYPE
	define_tag('ContentType', -namespace='_global_Client_', -priority='replace');
		return(string(_request_param('ctyp')));
	/define_tag;

	//CONTENT_LENGTH
	define_tag('ContentLength', -namespace='_global_Client_', -priority='replace');
		return(integer(_request_param('CLen')));
	/define_tag;

	//HTTP_USER_AGENT
	define_tag('Browser', -namespace='_global_Client_', -priority='replace');
		return(string(_request_param('Agnt')));
	/define_tag;
?>